Summary: TellStick controlling library
Name: telldus-core
Version: 2.1.2
Release: 9%{?dist}
License: LGPLv2.1+
URL: http://developer.telldus.se
Source0: http://download.telldus.se/TellStick/Software/telldus-core/%{name}-%{version}.tar.gz
Source1: telldus-core-2.1.2-manpages.tar.gz
Source2: telldusd.service
Patch0: telldus-core-2.1.1-run-under-dedicated-user.diff
Patch1: telldus-core-2.1.2_rc1-linkage_fix.diff
Patch2: telldus-core-2.1.2-socket_dir.diff
Patch3: 0001-Only-create-the-socket-once.-If-we-fail-to-connect-i.patch
Patch4: telldus-core-2.1.2-libftdi1.diff
Patch5: telldus-core-2.1.2-narrowing_fixes.diff
Patch6: 0001-Settings-PrivateData-init-pointers.patch
Patch7: telldus-core-2.1.2-FTBFS_FC36.diff
BuildRequires: libftdi-devel
BuildRequires: libusbx-devel
BuildRequires: libconfuse-devel
BuildRequires: systemd-devel
%if 0%{?rhel} == 7
BuildRequires: cmake3
# make it pull the correct arch
BuildRequires: python3-libs%{?_isa} python3%{?_isa}
%else
BuildRequires: cmake
%endif
BuildRequires: /usr/bin/perl
BuildRequires: gcc-c++
# making man pages is broken
BuildConflicts: doxygen
Requires: %{name}-libs >= %{version}-%{release}

%description
Telldus Core is the driver and tools for controlling a Telldus Technologies
TellStick. It does not containing any GUI tools which makes it suitable for
server use.
This package contains the tools.

%package libs
Summary: Library for telldus-core

%description libs
Telldus Core is the driver and tools for controlling a Telldus Technologies
TellStick. It does not containing any GUI tools which makes it suitable for
server use.
This package contains the library.

%package devel
Summary: Development files for developing programs against telldus-core
Requires: %{name}-libs >= %{version}-%{release}

%description devel
Telldus Core is the driver and tools for controlling a Telldus Technologies
TellStick. It does not containing any GUI tools which makes it suitable for
server use.
This package contains development files for creating applications using
Telldus Core.

%prep

%setup -q -a1
%patch0 -p1
%patch1 -p0
%patch2 -p1
%patch3 -p2
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1

perl -pi -e "s|/etc/udev/rules.d|%{_udevrulesdir}|g" tdadmin/CMakeLists.txt
perl -pi -e "s|%{_localstatedir}/state|%{_localstatedir}/lib/telldusd|g" service/CMakeLists.txt

%build

export CFLAGS="${CFLAGS:-%optflags -Wno-sign-compare}"
export CXXFLAGS="${CXXFLAGS:-%optflags -Wno-sign-compare}"

%if 0%{?rhel} == 7
%cmake3 \
    -DSCRIPT_PATH="%{_datadir}/telldus/scripts"

%cmake3_build -j1
%else
%cmake \
    -DSCRIPT_PATH="%{_datadir}/telldus/scripts"

%cmake_build -j1
%endif

%install
%if 0%{?rhel} == 7
%cmake3_install
%else
%cmake_install
%endif

install -d %{buildroot}%{_unitdir}
install -m0644 %{SOURCE2} %{buildroot}%{_unitdir}/telldusd.service

install -d %{buildroot}%{_datadir}/telldus/scripts
for i in controllerevent devicechangeevent deviceevent rawdeviceevent sensorevent; do
cat > %{buildroot}%{_datadir}/telldus/scripts/$i << EOF
#!/bin/sh
# add something interesting to do for the $i trigger here
EOF
done

install -d %{buildroot}%{_localstatedir}/lib/telldusd

install -d %{buildroot}%{_mandir}/man1
install man/*.1 %{buildroot}%{_mandir}/man1/

%pre
getent group telldusd >/dev/null || groupadd -r telldusd
getent passwd telldusd >/dev/null || useradd -r -g telldusd -d %{_localstatedir}/lib/telldusd -s /sbin/nologin -c "Telldus Daemon" telldusd

%post
%systemd_post telldusd.service

%preun
%systemd_preun telldusd.service

%postun
%systemd_postun_with_restart telldusd.service

%files
%doc AUTHORS README
%attr(0640,telldusd,telldusd) %config(noreplace) %{_sysconfdir}/tellstick.conf
%{_udevrulesdir}/05-tellstick.rules
%{_unitdir}/telldusd.service
%{_bindir}/tdtool
%{_sbindir}/tdadmin
%{_sbindir}/telldusd
%dir %{_datadir}/%{name}/
%dir %{_datadir}/%{name}/helpers/
%{_datadir}/%{name}/helpers/udev.sh
%dir %{_datadir}/telldus/scripts
%attr(0755,root,root) %config(noreplace) %{_datadir}/telldus/scripts/deviceevent
%attr(0755,root,root) %config(noreplace) %{_datadir}/telldus/scripts/devicechangeevent
%attr(0755,root,root) %config(noreplace) %{_datadir}/telldus/scripts/rawdeviceevent
%attr(0755,root,root) %config(noreplace) %{_datadir}/telldus/scripts/sensorevent
%attr(0755,root,root) %config(noreplace) %{_datadir}/telldus/scripts/controllerevent
%attr(0755,telldusd,telldusd) %dir %{_localstatedir}/lib/telldusd
%attr(0644,telldusd,telldusd) %config(noreplace) %{_localstatedir}/lib/telldusd/telldus-core.conf
%{_mandir}/man1/*

%files libs
%{_libdir}/lib%{name}.so.2*

%files devel
%{_includedir}/%{name}.h
%{_libdir}/*.so


%changelog
* Sun Nov 12 2023 Oden Eriksson <oe@nux.se> - 2.1.2-9
- rebuild for rhel 7 - 9 and latest fedora

* Sun Nov 12 2023 Oden Eriksson <oe@nux.se> - 2.1.2-8
- rebuild for rhel 7 - 9 and latest fedora

* Sun Nov 12 2023 Oden Eriksson <oe@nux.se> - 2.1.2-7
- rebuild

* Sun Jan 15 2023 Oden Eriksson <oe@nux.se> - 2.1.2-6
- P7: fixed differently and actually makes it work om FC36+

* Sun Jan 15 2023 Oden Eriksson <oe@nux.se> - 2.1.2-5
- fix build in the rhel 7 env

* Sun Jan 15 2023 Oden Eriksson <oe@nux.se> - 2.1.2-4
- make it build on RHEL 7 as well
- fix a bug with the service script

* Sun Jan 15 2023 Oden Eriksson <oe@nux.se> - 2.1.2-3
- P7: fix build on FC36+

* Mon Dec 26 2022 Oden Eriksson <oe@nux.se> - 2.1.2-2
- update P5 from freebsd which makes it build on RHEL 9 as well

* Mon Dec 26 2022 Oden Eriksson <oe@nux.se> - 2.1.2-1
- build release for RHEL 8
- add BR and build fixes

* Fri Jul 27 2018 Oden Eriksson <oe@nux.se> - 2.1.2-1.1
- rebuild

* Sun Mar 19 2017 Oden Eriksson <oe@nux.se> - 2.1.2-1
- adapt for CentOS 7

* Mon Feb 08 2016 umeabot <umeabot> 2.1.2-3.mga6
+ Revision: 950223
- Mageia 6 Mass Rebuild

* Sat Oct 25 2014 oden <oden> 2.1.2-2.mga5
+ Revision: 793163
- really fix build
- P4: fix build (libftdi1)
- fix deps
- also add the patch
- P3:  Only create the socket once. If we fail to connect is we should try to reuse it later.
- various fixes
- fix group
- various fixes
- imported package telldus-core
